commit 79e44ca9db7cc0871668957158fc12d1dcc27b94
Author: D0miq <dpoch@email.com>
Date:   Sun Jun 2 01:07:32 2019 +0200

    Documentation domain and dto, unit test domain, error input domain

diff --git a/server/src/main/java/cz/zcu/yamanager/business/ApiManager.java b/server/src/main/java/cz/zcu/yamanager/business/ApiManager.java
index 98ab2f2..402211a 100644
--- a/server/src/main/java/cz/zcu/yamanager/business/ApiManager.java
+++ b/server/src/main/java/cz/zcu/yamanager/business/ApiManager.java
@@ -12,10 +12,14 @@ import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.jdbc.core.JdbcTemplate;
 import org.springframework.stereotype.Component;
 
+import java.time.Duration;
 import java.time.LocalDate;
+import java.time.temporal.TemporalUnit;
 import java.util.Collections;
 import java.util.List;
 
+import static java.time.temporal.ChronoUnit.MINUTES;
+
 @Component
 public class ApiManager implements Manager {
 
@@ -46,18 +50,15 @@ public class ApiManager implements Manager {
             users = this.userRepository.getAllBasicUsers(status);
         }
 
-        if(users == null) {
-            return Collections.emptyList();
-        } else {
-            LocalDate today = LocalDate.now();
-            LocalDate weekBefore = today.minusDays(ApiManager.DAYS_IN_WEEK);
-            LocalDate weekAfter = today.plusDays(ApiManager.DAYS_IN_WEEK);
-            for (BasicProfileUser user : users) {
-                user.setCalendar(this.vacationRepository.getVacationDays(user.getId(), weekBefore, weekAfter));
-            }
-
-            return users;
+        LocalDate today = LocalDate.now();
+        LocalDate weekBefore = today.minusDays(ApiManager.DAYS_IN_WEEK);
+        LocalDate weekAfter = today.plusDays(ApiManager.DAYS_IN_WEEK);
+        for (BasicProfileUser user : users) {
+            user.setCalendar(this.vacationRepository.getVacationDays(user.getId(), weekBefore, weekAfter));
         }
+
+        return users;
+
     }
 
     @Override
@@ -69,7 +70,7 @@ public class ApiManager implements Manager {
             requests = this.requestRepository.getAllVacationRequests(status);
         }
 
-        return requests == null ? Collections.emptyList() : requests;
+        return requests;
     }
 
     @Override
@@ -81,15 +82,12 @@ public class ApiManager implements Manager {
             requests = this.requestRepository.getAllAuthorizations(status);
         }
 
-        return requests == null ? Collections.emptyList() : requests;
+        return requests;
     }
 
     @Override
     public FullUserProfile getUserProfile(Long userId) throws RESTFullException {
-        FullUserProfile userProfile = this.userRepository.getFullUser(userId);
-        System.out.println("Notification: " + userProfile.getNotification());
-        System.out.println("Approval: " + userProfile.getStatus());
-        return userProfile;
+        return this.userRepository.getFullUser(userId);
     }
 
     @Override
@@ -111,7 +109,7 @@ public class ApiManager implements Manager {
             vacations = this.vacationRepository.getVacationDays(userId, fromDate, status);
         }
 
-        return vacations == null ? Collections.emptyList() : vacations;
+        return vacations;
     }
 
     @Override
@@ -121,13 +119,22 @@ public class ApiManager implements Manager {
 
     @Override
     public void createVacation(Long userId, VacationDay vacationDay) throws RESTFullException {
+        UserRole role = this.userRepository.getUserRole(userId);
+        vacationDay.setStatus(role == UserRole.EMPLOYER ? Status.ACCEPTED : Status.PENDING);
+
+        if(vacationDay.getType() == VacationType.VACATION) {
+            this.userRepository.decreaseVacationCount(userId, vacationDay.getFrom().until(vacationDay.getTo(), MINUTES) / 60f);
+        } else {
+            this.userRepository.increaseTakenSickdays(userId);
+        }
+
         this.vacationRepository.insertVacationDay(userId, vacationDay);
     }
 
     @Override
     public void changeSettings(Long userId, UserSettings settings) throws RESTFullException {
         settings.setId(userId);
-        if(settings.getRole() == null && settings.getSickdayCount() == null && settings.getVacationCount() == null) {
+        if(settings.getRole() == null && settings.getSickDayCount() == null && settings.getVacationCount() == null) {
             this.userRepository.updateNotification(settings);
         } else {
             this.userRepository.updateUserSettings(settings);
diff --git a/server/src/main/java/cz/zcu/yamanager/business/mock/ManagerMock.java b/server/src/main/java/cz/zcu/yamanager/business/mock/ManagerMock.java
index 2a81f6b..608986a 100644
--- a/server/src/main/java/cz/zcu/yamanager/business/mock/ManagerMock.java
+++ b/server/src/main/java/cz/zcu/yamanager/business/mock/ManagerMock.java
@@ -109,11 +109,11 @@ public class ManagerMock implements Manager {
         if (userSettings.containsKey(id)) {
             UserSettings settings = userSettings.get(id);
             user.setVacationCount(settings.getVacationCount());
-            user.setSickdayCount(settings.getSickdayCount());
+            user.setSickDayCount(settings.getSickDayCount());
             user.setRole(settings.getRole());
         } else {
             user.setVacationCount(8.5F);
-            user.setSickdayCount(3);
+            user.setSickDayCount(3);
             user.setRole(UserRole.EMPLOYER);
         }
 
@@ -125,7 +125,7 @@ public class ManagerMock implements Manager {
     private DefaultSettings createDefaultSettings() {
         DefaultSettings settings = new DefaultSettings();
 
-        settings.setSickdayCount(3);
+        settings.setSickDayCount(3);
         settings.setNotification(LocalDateTime.now());
 
         return settings;
diff --git a/server/src/main/java/cz/zcu/yamanager/domain/DefaultSettings.java b/server/src/main/java/cz/zcu/yamanager/domain/DefaultSettings.java
index 88cd354..6fa5417 100644
--- a/server/src/main/java/cz/zcu/yamanager/domain/DefaultSettings.java
+++ b/server/src/main/java/cz/zcu/yamanager/domain/DefaultSettings.java
@@ -1,114 +1,129 @@
 package cz.zcu.yamanager.domain;
 
-import java.time.LocalDate;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import java.time.LocalDateTime;
 
 /**
- * A domain class {@code DefaultSettings} represents a single record in the Default_settings table of a database.
- * It contains default settings of the application.
+ * The domain class {@code DefaultSettings} represents a single record in the 'default_settings' table of a database.
+ * It contains default settings of users' informations that are known to the application. Informations consist of a number of
+ * available sick days, date and time of an email notification. Default settings are mainly used when the user is added to
+ * the application which means he/she can't have his/her own values.
  */
 public class DefaultSettings {
-
     /**
-     * ID of the default settings.
+     * The logger.
      */
-    private final int id;
+    private static final Logger log = LoggerFactory.getLogger(DefaultSettings.class);
 
     /**
-     * Default remaining vacation hours.
+     * The ID of default settings.
      */
-    private int noVacations;
+    private final long id;
 
     /**
-     * Default remaining sick days.
+     * The default number of available sick days.
      */
-    private int noSickDays;
+    private int sickDayCount;
 
     /**
-     * Default date of an email warning about an incoming reset of the vacation hours and sick days.
+     * The default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days.
      */
-    private LocalDate alertDate;
+    private LocalDateTime notification;
 
     /**
-     * Creates a new instance of the class {@code DefaultSettings}.
-     * @param id ID of the default settings.
-     * @param noVacations Default remaining vacation hours.
-     * @param noSickDays Default remaining sick days.
-     * @param alertDate Default date of an email warning about an incoming reset of the vacation hours and sick days.
+     * Creates an empty default settings for testing purposes only.
+     * It just sets id to zero.
      */
-    public DefaultSettings(int id, int noVacations, int noSickDays, LocalDate alertDate) {
-        this.id = id;
-        this.noVacations = noVacations;
-        this.noSickDays = noSickDays;
-        this.alertDate = alertDate;
+    public DefaultSettings() {
+        DefaultSettings.log.trace("Creating a new instance of the class DefaultSettings.");
+        this.id = 0;
     }
 
     /**
-     * Gets an ID of the default settings.
-     * @return The ID of the default settings.
+     * Creates a new default settings with the specified id, number of available sick days, date and time of a notification.
+     *
+     * @param id           the ID of default settings
+     * @param sickDayCount the default number of available sick days
+     * @param notification the default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days
+     * @throws IllegalArgumentException when the given sickDayCount value is negative
      */
-    public int getId() {
-        return id;
-    }
+    public DefaultSettings(final long id, final int sickDayCount, final LocalDateTime notification) throws IllegalArgumentException {
+        DefaultSettings.log.trace("Creating a new instance of the class DefaultSettings.");
+        DefaultSettings.log.debug("DefaultSettings: id={},\nsickDayCount={},\nnotification={}", id, sickDayCount, notification);
 
-    /**
-     * Gets a default remaining vacation hours.
-     * @return The default remaining vacation hours.
-     */
-    public int getNoVacations() {
-        return noVacations;
+        this.id = id;
+        this.setSickDayCount(sickDayCount);
+        this.notification = notification;
     }
 
     /**
-     * Sets a new default remaining vacation hours.
-     * @param noVacations The new default remaining vacation hours.
+     * Returns the ID of this default settings.
+     *
+     * @return the ID of this default settings
      */
-    public void setNoVacations(int noVacations) {
-        this.noVacations = noVacations;
+    public long getId() {
+        return this.id;
     }
 
     /**
-     * Gets a default remaining sick days.
-     * @return The default remaining sick days.
+     * Returns the default number of available sick days in this default settings.
+     *
+     * @return the default number of available sick days
      */
-    public int getNoSickDays() {
-        return noSickDays;
+    public int getSickDayCount() {
+        return this.sickDayCount;
     }
 
     /**
-     * Sets a new default remaining sick days.
-     * @param noSickDays The new default remaining sick days.
+     * Replaces the default number of available sick days in this default settings with the given one.
+     * If the given number is negative the method throws an exception.
+     *
+     * @param sickDayCount the new default number of available sick days
+     * @throws IllegalArgumentException when the given value is negative
      */
-    public void setNoSickDays(int noSickDays) {
-        this.noSickDays = noSickDays;
+    public void setSickDayCount(final int sickDayCount) throws IllegalArgumentException {
+        DefaultSettings.log.debug("Setting a new number of available sick days: {}.", sickDayCount);
+
+        if (sickDayCount < 0) {
+            DefaultSettings.log.warn("The number of available sick days was negative.");
+            throw new IllegalArgumentException("sick.day.count.error");
+        }
+
+        this.sickDayCount = sickDayCount;
     }
 
     /**
-     * Gets a default date of an email warning about an incoming reset of the vacation hours and sick days.
-     * @return The default date of an email warning about an incoming reset of the vacation hours and sick days.
+     * Returns the default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days.
+     *
+     * @return the default date and time
      */
-    public LocalDate getAlertDate() {
-        return alertDate;
+    public LocalDateTime getNotification() {
+        return this.notification;
     }
 
     /**
-     * Sets a new default date of an email warning about an incoming reset of the vacation hours and sick days.
-     * @param alertDate The new default date of an email warning about an incoming reset of the vacation hours and sick days.
+     * Replaces the default date and time of sending an email warning about an incoming reset of remaining overtimes and sick days with the specified one.
+     *
+     * @param notification the new default date and time
      */
-    public void setAlertDate(LocalDate alertDate) {
-        this.alertDate = alertDate;
+    public void setNotification(final LocalDateTime notification) {
+        DefaultSettings.log.debug("Setting a new default date and time of sending an email warning: {}.", notification);
+        this.notification = notification;
     }
 
     /**
-     * Gets a string representation of the class {@code DefaultSettings}.
-     * @return The string representation of the class.
+     * Returns a string representation of this default settings. The representation consists of the id, number of sick days and notification of the default settings.
+     *
+     * @return the string representation of this default settings
      */
     @Override
     public String toString() {
         return "DefaultSettings{" +
-                "id=" + id +
-                ", noVacations=" + noVacations +
-                ", noSickDays=" + noSickDays +
-                ", alertDate=" + alertDate +
+                "id=" + this.id +
+                ", sickDayCount=" + this.sickDayCount +
+                ", notification=" + this.notification +
                 '}';
     }
 }
